import onnx
import ktc
#model_maxmIOU50_stdc-full.pth
import torch

import torch.onnx 
import os
from importlib import reload  # Python 3.4+

from model import *
# reload(model)
print(torch.__version__)
#Function to Convert to ONNX 
bs=1

def Convert_ONNX(model, fn, width=4): 

    # set the model to inference mode 
    model.cpu().eval() 

    # Let's create a dummy input tensor  
    dummy_input = torch.randn(bs, 172,128, width)

    # Export the model   
    torch.onnx.export(model, 
                      dummy_input, 
                      fn, 
                      opset_version=11,
                      input_names=['input'], 
                      output_names=['output'],
                      keep_initializers_as_inputs=True
                     )
    print(" ") 
    print('Model has been converted to ONNX') 
    

print(torch.__version__)


model3 = DFModel_TSN(device='cpu',cr=1, stream=3)  
Convert_ONNX(model3, '/Kneron/rtcs.onnx')

res = onnx.load('/Kneron/rtcs.onnx')
result_m = ktc.onnx_optimizer.torch_exported_onnx_flow(res)
optimized_m = ktc.onnx_optimizer.onnx2onnx_flow(result_m, eliminate_tail=False, opt_matmul=False)

onnx.save(optimized_m, '/Kneron/optimized.onnx')


import onnx
import ktc
import torch
print(torch.__version__)


# # # km = ktc.ModelConfig(id, version, platform, onnx_model=None, onnx_path=None, bie_path=None)
# res = onnx.load('/Kneron/optimized.onnx')
km = ktc.ModelConfig(32769, "1111", "720", onnx_model=optimized_m)
eval_result = km.evaluate()
print(eval_result)

input_mapping = {"input":[np.random.rand(1,128,4, 172).astype(np.float32) for _ in range(12)] }
input_data  = [np.random.rand(1,128,4, 172).astype(np.float32)]
# print(input_mapping['input'].shape)

# Quantization
bie_path = km.analysis(input_mapping, output_bie = None, threads = 4, quantize_mode='default', bitwidth_mode=8)
print('BIE Quantization', bie_path)
# fixed_results = ktc.kneron_inference(input_data, bie_file=bie_path, input_names=["input"])
# print('fixed_results:', fixed_results[0].shape)


print('BIE Quantization Inference')
compile_result = ktc.compile([km])
print(compile_result)


